10     DIM Pri$[9],Sec$[9],Range$[9],Mode$[9],Aux$[9],Low_c_rej$[9],Img$[50]
20     REAL Nom,L_lim(1:3),U_lim(1:3),L_lim_sec,U_lim_sec
30     REAL Low_c_rej_lim,Pri_para,Sec_para
40     INTEGER I,Meas_stat,Comp,Bin(1:11),Ovld
50     !
60     ASSIGN @Agt4288a TO 717
70     !
80     Pri$="CP"
90     Sec$="D"
100    Range$="1NF"
110    !
120    Mode$="PCNT"
130    Nom=1.E-9
140    !-- [BIN1] --
150    L_lim(1)=-1.0
160    U_lim(1)=1.0
170    !-- [BIN2] --
180    L_lim(2)=-2.0
190    U_lim(2)=2.0
200    !-- [BIN3] --
210    L_lim(3)=-3.0
220    U_lim(3)=3.0
230    !-- [Sec] --
240    L_lim_sec=0.
250    U_lim_sec=.1
260    !
270    Aux$="ON"
280    Low_c_rej$="ON"
290    Low_c_rej_lim=10.0
300    !
310    OUTPUT @Agt4288a;":SYST:PRES"
320    !
330    ! Measurement Condition Setting
340    !
350    OUTPUT @Agt4288a;":CALC1:FORM "&Pri$
360    OUTPUT @Agt4288a;":CALC2:FORM "&Sec$
370    OUTPUT @Agt4288a;":RANG "&Range$
380    !
390    ! Comparator Setting
400    !
410    OUTPUT @Agt4288a;":CALC:COMP:MODE "&Mode$
420    OUTPUT @Agt4288a;":CALC:COMP:PRIM:NOM ";Nom
430    FOR I=1 TO 3
440      OUTPUT @Agt4288a;":CALC:COMP:PRIM:BIN"&VAL$(I)&" ";L_lim(I);",";U_lim(I)
450      OUTPUT @Agt4288a;":CALC:COMP:PRIM:BIN"&VAL$(I)&":STAT ON"
460    NEXT I
470    FOR I=4 TO 9
480      OUTPUT @Agt4288a;":CALC:COMP:PRIM:BIN"&VAL$(I)&":STAT OFF"
490    NEXT I
500    OUTPUT @Agt4288a;":CALC:COMP:SEC:LIM ";L_lim_sec;",";U_lim_sec
510    OUTPUT @Agt4288a;":CALC:COMP:SEC:STAT ON"
520    !
530    OUTPUT @Agt4288a;":CALC:COMP:AUXB "&Aux$
540    OUTPUT @Agt4288a;":CREJ "&Low_c_rej$
550    OUTPUT @Agt4288a;":CREJ:LIM ";Low_c_rej_lim
560    OUTPUT @Agt4288a;":CALC:COMP ON"
570    OUTPUT @Agt4288a;":DISP:TEXT2:PAGE 6"
580    !
590    ! Trigger setting
600    !
610    OUTPUT @Agt4288a;":TRIG:SOUR BUS"
620    !
630    ! Bin count setting
640    !
650    OUTPUT @Agt4288a;":CALC:COMP:COUN ON"
660    OUTPUT @Agt4288a;":CALC:COMP:COUN:CLE"
670    OUTPUT @Agt4288a;"*OPC?"
680    ENTER @Agt4288a;Buff$
690    !
700    ! Measurement
710    !
720    CLEAR SCREEN
730    Img$="3D,3X,D,4X,MD.4DE,2X,MD.4DE,2X,2D"
740    PRINT "[MEASUREMENT and BIN SORT RESULT]"
750    PRINT "    Status    "&Pri$&"           "&Sec$&"        BIN"
760    PRINT " ----------------------------------------"
770    FOR I=1 TO 50
780      OUTPUT @Agt4288a;"*TRG"
790      ENTER @Agt4288a;Meas_stat,Pri_para,Sec_para,Comp
800      PRINT USING Img$;I,Meas_stat,Pri_para,Sec_para,Comp
810    NEXT I
820    OUTPUT @Agt4288a;":CALC:COMP:COUN:DATA?"
830    ENTER @Agt4288a;Bin(*)
840    OUTPUT @Agt4288a;":CALC:COMP:COUN:OVLD?"
850    ENTER @Agt4288a;Ovld
860    Img$="2X,17A,5D"
870    PRINT "[BIN COUNT RESULT]"
880    PRINT "   BIN             Count"
890    PRINT " ------------------------"
900    FOR I=1 TO 9
910      PRINT USING Img$;"BIN"&VAL$(I)&":",Bin(I)
920    NEXT I
930    PRINT USING Img$;"OUT OF BINS:",Bin(10)
940    PRINT USING Img$;"AUX BIN:",Bin(11)
950    PRINT USING Img$;"OVLD:",Ovld
960    !
970    END
5000   !*************************************************
5010   !* DESCRIPTION:  Agilent 4288A Sample Program
5020   !*
5030   !* AUTHOR:       Agilent Technologies Japan, Ltd.
5040   !* CREATED:      12/1/2000
5050   !* PROGRAM NAME: comprtr.bas
5060   !* REVISION:     A.01.00
5070   !*
5080   !*     Copyright (c) Agilent Technologies,
5090   !*              All rights reserved.
5100   !*
5110   !*
5120   !*  Customer shall have the personal, non-
5130   !* transferable rights to use, copy or modify
5140   !* this SAMPLE PROGRAM for Customer's internal
5150   !* operations. Customer shall use the SAMPLE
5160   !* PROGRAM solely and exclusively for its own
5170   !* purpose and shall not license, lease, market
5180   !* or distribute the SAMPLE PROGRAM or
5190   !* modification or any part thereof.
5200   !*
5210   !*  Agilent Technologies shall not be liable for
5220   !* the quality, performance or behavior of the
5230   !* SAMPLE PROGRAM. Agilent Technologies especially
5240   !* disclaims that the operation of the SAMPLE
5250   !* PROGRAM shall be uninterrupted or error free.
5260   !* This SAMPLE PROGRAM is provided AS IS.
5270   !*
5280   !*  AGILENT TECHNOLOGIES DISCLAIMS THE IMPLIED
5290   !* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
5300   !* A PARTICULAR PURPOSE.
5310   !*
5320   !*  Agilent Technologies shall not be liable for
5330   !* any infringement of any patent, trademark,
5340   !* copyright or other proprietary rights by the
5350   !* SAMPLE PROGRAM or its use. Agilent Technologies
5360   !* does not warrant that the SAMPLE PROGRAM is
5370   !* free from infringements or such rights of third
5380   !* parties. However, Agilent Technologies will not
5390   !* knowingly infringe or deliver a software that
5400   !* infringes the patent, trademark, copyright or
5410   !* other proprietary right of a third party.
5420   !*
5430   !*************************************************
