10     DIM Pri$[9],Sec$[9],Mode$[9],Aux$[9],Meas_time$[9],Low_c_rej$[9]
20     DIM Digit$[1],Read_form$[9],Num_of_byte$[9],Buff$[9],Img$[50]
30     REAL Freq,Lvl,Data(0:3,1:4),Nom,Low_c_rej_lim
40     REAL L_lim(1:3),U_lim(1:3),L_lim_sec,U_lim_sec,Pri_res,Sec_res
50     INTEGER Max_meas,Max_chan,Cbl,Result,Ch,Bin(1:11),Ovld,I
60     CLEAR SCREEN
70     !
80     ASSIGN @Binary TO 717;FORMAT OFF
90     ASSIGN @Agt4288a TO 717
100    !
110    Max_meas=10
120    Max_chan=3
130    !
140    Pri$="CP"
150    Sec$="D"
160    Freq=1.E+3
170    Lvl=1.0
180    Meas_time$="SHOR"
190    Cbl=1
200    !
210    Mode$="PCNT"
220    Nom=1.E-9
230    !-- [BIN1] --
240    L_lim(1)=-1.0
250    U_lim(1)=1.0
260    !-- [BIN2] --
270    L_lim(2)=-2.0
280    U_lim(2)=2.0
290    !-- [BIN3] --
300    L_lim(3)=-3.0
310    U_lim(3)=3.0
320    !-- [Sec] --
330    L_lim_sec=0.
340    U_lim_sec=.1
350    Aux$="ON"
360    Low_c_rej$="ON"
370    Low_c_rej_lim=10.0
380    !
390    OUTPUT @Agt4288a;"*RST"
400    OUTPUT @Agt4288a;":CALC1:FORM ";Pri$
410    OUTPUT @Agt4288a;":CALC2:FORM ";Sec$
420    OUTPUT @Agt4288a;":SOUR:FREQ ";Freq
430    OUTPUT @Agt4288a;":SOUR:VOLT ";Lvl
440    OUTPUT @Agt4288a;":APER "&Meas_time$
450    OUTPUT @Agt4288a;":CAL:CABL ";Cbl
460    !
470    OUTPUT @Agt4288a;":CORR:MULT ON"
480    OUTPUT @Agt4288a;":CORR:MULT:CKIT:STAN3 ON"
490    OUTPUT @Agt4288a;":DISP:TEXT2:PAGE 5"
500    !
510    OUTPUT @Agt4288a;":SYST:BEEP:STAT OFF"
520    OUTPUT @Agt4288a;":SYST:KLOC ON"
530    !
540    ! Compensation
550    !
560    PRINT "##### Open Data Measurement #####"
570    FOR Ch=0 TO Max_chan
580      OUTPUT @Agt4288a;":CORR:MULT:CHAN ";Ch
590      PRINT "Set the Scanner's Channel to No."&VAL$(Ch)&", and"
600      Result=FNCompen(@Agt4288a,"Open",.00002)
610      IF Result<>0 THEN Prog_end
620    NEXT Ch
630    PRINT "##### Short Data Measurement #####"
640    FOR Ch=0 TO Max_chan
650      OUTPUT @Agt4288a;":CORR:MULT:CHAN ";Ch
660      PRINT "Set the Scanner's Channel to No."&VAL$(Ch)&", and"
670      Result=FNCompen(@Agt4288a,"Short",20)
680      IF Result<>0 THEN Prog_end
690    NEXT Ch
700    PRINT "##### Load Data Measurement #####"
710    FOR Ch=0 TO Max_chan
720      OUTPUT @Agt4288a;":CORR:MULT:CHAN ";Ch
730      PRINT "Set the Scanner's Channel to No."&VAL$(Ch)&", and"
740      Result=FNCompen(@Agt4288a,"Load",.2)
750      IF Result<>0 THEN Prog_end
760    NEXT Ch
770    !
780    OUTPUT @Agt4288a;":RANG ";Nom
790    !
800    ! Comparator Setting
810    !
820    OUTPUT @Agt4288a;":CALC:COMP:MODE "&Mode$
830    OUTPUT @Agt4288a;":CALC:COMP:PRIM:NOM ";Nom
840    FOR I=1 TO 3
850      OUTPUT @Agt4288a;":CALC:COMP:PRIM:BIN"&VAL$(I)&" ";L_lim(I);",";U_lim(I)
860      OUTPUT @Agt4288a;":CALC:COMP:PRIM:BIN"&VAL$(I)&":STAT ON"
870    NEXT I
880    FOR I=4 TO 9
890      OUTPUT @Agt4288a;":CALC:COMP:PRIM:BIN"&VAL$(I)&":STAT OFF"
900    NEXT I
910    OUTPUT @Agt4288a;":CALC:COMP:SEC:LIM ";L_lim_sec;",";U_lim_sec
920    OUTPUT @Agt4288a;":CALC:COMP:SEC:STAT ON"
930    !
940    OUTPUT @Agt4288a;":CALC:COMP:AUXB "&Aux$
950    OUTPUT @Agt4288a;":CREJ "&Low_c_rej$
960    OUTPUT @Agt4288a;":CREJ:LIM ";Low_c_rej_lim
970    OUTPUT @Agt4288a;":CALC:COMP ON"
980    !
990    ! Trigger setting
1000   !
1010   OUTPUT @Agt4288a;":TRIG:SOUR EXT"
1020   OUTPUT @Agt4288a;":INIT:CONT ON"
1030   !
1040   ! Bin count setting
1050   !
1060   OUTPUT @Agt4288a;":CALC:COMP:COUN ON"
1070   OUTPUT @Agt4288a;":CALC:COMP:COUN:CLE"
1080   OUTPUT @Agt4288a;"*OPC?"
1090   ENTER @Agt4288a;Buff$
1100   !
1110   ! SRQ setting
1120   !
1130   OUTPUT @Agt4288a;":STAT:OPER:ENAB 16"
1140   OUTPUT @Agt4288a;"*SRE 128"
1150   !
1160   ! Data buffer setting
1170   !
1180   OUTPUT @Agt4288a;":DATA:POIN BUF3,";Max_chan+1
1190   OUTPUT @Agt4288a;":DATA:FEED:CONT BUF3,ALW"
1200   OUTPUT @Agt4288a;":FORM REAL"
1210   !
1220   FOR I=1 TO Max_meas
1230     PRINT "Set DUT of All Channels."
1240     !
1250     FOR Ch=0 TO Max_chan
1260       OUTPUT @Agt4288a;":CORR:MULT:CHAN ";Ch
1270       OUTPUT @Agt4288a;"*CLS"
1280       OUTPUT @Agt4288a;"*OPC?"
1290       ENTER @Agt4288a;Buff$
1300       ON INTR 7 GOTO Meas_end
1310       ENABLE INTR 7;2
1320       PRINT "Set the Scanner's Channel to No."&VAL$(Ch)&"."
1330       PRINT "Input External Trigger!"
1340 Meas_wait: GOTO Meas_wait
1350 Meas_end: OFF INTR 7
1360     NEXT Ch
1370     !
1380     OUTPUT @Agt4288a;":DATA? BUF3"
1390     ENTER @Agt4288a USING "#,A";Buff$
1400     ENTER @Agt4288a USING "#,A";Digit$
1410     Read_form$="#,"&Digit$&"A"
1420     ENTER @Agt4288a USING Read_form$;Num_of_byte$
1430     ENTER @Binary;Data(*)
1440     ENTER @Agt4288a USING "#,A";Buff$
1450     !
1460     Img$="2X,2D,7X,D,3X,SD.5DE,2X,SD.5DE,2X,2D"
1470     PRINT "[MEASUREMENT RESULT]"
1480     PRINT "CH No.  STATUS       "&Pri$&"             "&Sec$&"      BIN"
1490     PRINT "----------------------------------------------"
1500     FOR Ch=0 TO Max_chan
1510       PRINT USING Img$;Ch,Data(Ch,1),Data(Ch,2),Data(Ch,3),Data(Ch,4)
1520     NEXT Ch
1530   NEXT I
1540   !
1550   Img$="2X,2D,3X,5D,3X,5D,3X,5D,3X,5D,3X,5D,3X,5D"
1560   PRINT "[BIN COUNT RESULT]"
1570   PRINT "CH No.   BIN1    BIN2    BIN3     OUT     AUX    OVLD"
1580   PRINT "-----------------------------------------------------"
1590   FOR Ch=0 TO Max_chan
1600     OUTPUT @Agt4288a;":CORR:MULT:CHAN ";Ch
1610     OUTPUT @Agt4288a;":CALC:COMP:COUN:MULT:DATA?"
1620     ENTER @Agt4288a;Bin(*)
1630     OUTPUT @Agt4288a;":CALC:COMP:COUN:MULT:OVLD?"
1640     ENTER @Agt4288a;Ovld
1650     PRINT USING Img$;Ch,Bin(1),Bin(2),Bin(3),Bin(10),Bin(11),Ovld
1660   NEXT Ch
1670   !
1680 Prog_end: END
1690   !=============================================
1700   ! Compensation Data Measurement Function
1710   !=============================================
1720 DEF FNCompen(@Agt4288a,Standard$,Limit)
1730   DIM Inp_char$[9],Buff$[9],Std$[9],Err$[50]
1740   REAL Curr_freq,Freq(1:2),Para1,Para2,Zm,Ym,Gm,Bm
1750   REAL Cpref,Dref,Zref,Gref,Bref
1760   INTEGER Err_flag
1770   OUTPUT @Agt4288a;":SOUR:FREQ?"
1780   ENTER @Agt4288a;Curr_freq
1790   Freq(1)=1.E+3
1800   Freq(2)=1.E+6
1810   Load_para$="CPD"
1820   OUTPUT @Agt4288a;":STAT:OPER:ENAB 128"
1830   OUTPUT @Agt4288a;"*SRE 128"
1840   SELECT Standard$
1850     CASE "Open"
1860       Std$="STAN1"
1870     CASE "Short"
1880       Std$="STAN2"
1890     CASE "Load"
1900       Std$="STAN3"
1910       CALL Inp_data("Load(Cp) Value @1kHz",Load1(1))
1920       CALL Inp_data("Load(D)  Value @1kHz",Load2(1))
1930       CALL Inp_data("Load(Cp) Value @1MHz",Load1(2))
1940       CALL Inp_data("Load(D)  Value @1MHz",Load2(2))
1950       OUTPUT @Agt4288a;":CORR:CKIT:STAN3:FORM "&Load_para$
1960       FOR I=1 TO 2
1970         OUTPUT @Agt4288a;":SOUR:FREQ ";Freq(I)
1980         OUTPUT @Agt4288a;":CORR:CKIT:STAN3 ";Load1(I);",";Load2(I)
1990       NEXT I
2000   END SELECT
2010 Compen_meas: !
2020   PRINT "Set "&Standard$&"-Connection."
2030   INPUT "OK? [Y/N]",Inp_char$
2040   IF UPC$(Inp_char$)="Y" THEN 
2050     FOR I=1 TO 2
2060       PRINT "Frequency:";Freq(I)
2070       OUTPUT @Agt4288a;":SOUR:FREQ ";Freq(I)
2080       OUTPUT @Agt4288a;"*CLS"
2090       OUTPUT @Agt4288a;"*OPC?"
2100       ENTER @Agt4288a;Buff$
2110       ! Measurement
2120       ON INTR 7 GOTO Meas_end
2130       ENABLE INTR 7;2
2140       OUTPUT @Agt4288a;":CORR:COLL "&Std$
2150 Meas_wait: GOTO Meas_wait
2160 Meas_end: OFF INTR 7
2170       ! Error Check
2180       OUTPUT @Agt4288a;":SYST:ERR?"
2190       ENTER @Agt4288a;Err_no,Err$
2200       IF Err_no<>0 THEN 
2210         PRINT "Error: "&Err$
2220         GOTO Compen_meas
2230       END IF
2240       ! Data Check
2250       OUTPUT @Agt4288a;":CORR:DATA? "&Std$
2260       ENTER @Agt4288a;Para1,Para2
2270       Err_flag=0
2280       SELECT Standard$
2290         CASE "Open"
2300           Ym=SQRT(Para1*Para1+Para2*Para2)
2310           PRINT "G =";Para1,"B =";Para2,"|Y| =";Ym
2320           IF Ym>=Limit THEN Err_flag=1
2330         CASE "Short"
2340           Zm=SQRT(Para1*Para1+Para2*Para2)
2350           PRINT "R =";Para1,"X =";Para2,"|Z| =";Zm
2360           IF Zm>=Limit THEN Err_flag=1
2370         CASE "Load"
2380           OUTPUT @Agt4288a;":CORR:CKIT:STAN3?"
2390           ENTER @Agt4288a;Cpref,Dref
2400           Bref=2*PI*Freq(I)*Cpref
2410           Gref=Bref*Dref
2420           Zref=1/SQRT(Gref*Gref+Bref*Bref)
2430           Bm=2*PI*Freq(I)*Para1
2440           Gm=Bm*Para2
2450           Zm=1/SQRT(Gm*Gm+Bm*Bm)
2460           PRINT "Cpref=";Cpref,"Dref=";Dref,"|Zref| =";Zref
2470           PRINT "Cp   =";Para1,"D   =";Para2,"|Z|    =";Zm
2480           IF ABS((Zm-Zref)/Zref)>=Limit THEN Err_flag=1
2490       END SELECT
2500       IF Err_flag<>0 THEN 
2510         PRINT "Out of limit!!"
2520         GOTO Compen_meas
2530       END IF
2540     NEXT I
2550     PRINT Standard$&" Data Measurement Complete"
2560     OUTPUT @Agt4288a;":SOUR:FREQ ";Curr_freq
2570     RETURN 0
2580   ELSE
2590     PRINT "Program Interruption"
2600     OUTPUT @Agt4288a;":SOUR:FREQ ";Curr_freq
2610     RETURN -1
2620   END IF
2630 FNEND
2640   !=============================================
2650   ! Data Input Function
2660   !=============================================
2670 SUB Inp_data(Mes$,Inp_val)
2680   DIM Inp_char$[30]
2690   ON ERROR GOTO Inp_start
2700 Inp_start:!
2710   PRINT "Input "&Mes$
2720   INPUT "Value?",Inp_char$
2730   Inp_val=VAL(UPC$(Inp_char$))
2740   PRINT "Input Value: ";Inp_val
2750   INPUT "OK? [Y/N]",Inp_char$
2760   IF UPC$(Inp_char$)<>"Y" THEN Inp_start
2770   OFF ERROR 
2780 SUBEND
5000   !*************************************************
5010   !* DESCRIPTION:  Agilent 4288A Sample Program
5020   !*
5030   !* AUTHOR:       Agilent Technologies Japan, Ltd.
5040   !* CREATED:      12/1/2000
5050   !* PROGRAM NAME: meas_scn.bas
5060   !* REVISION:     A.01.00
5070   !*
5080   !*     Copyright (c) Agilent Technologies,
5090   !*              All rights reserved.
5100   !*
5110   !*
5120   !*  Customer shall have the personal, non-
5130   !* transferable rights to use, copy or modify
5140   !* this SAMPLE PROGRAM for Customer's internal
5150   !* operations. Customer shall use the SAMPLE
5160   !* PROGRAM solely and exclusively for its own
5170   !* purpose and shall not license, lease, market
5180   !* or distribute the SAMPLE PROGRAM or
5190   !* modification or any part thereof.
5200   !*
5210   !*  Agilent Technologies shall not be liable for
5220   !* the quality, performance or behavior of the
5230   !* SAMPLE PROGRAM. Agilent Technologies especially
5240   !* disclaims that the operation of the SAMPLE
5250   !* PROGRAM shall be uninterrupted or error free.
5260   !* This SAMPLE PROGRAM is provided AS IS.
5270   !*
5280   !*  AGILENT TECHNOLOGIES DISCLAIMS THE IMPLIED
5290   !* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
5300   !* A PARTICULAR PURPOSE.
5310   !*
5320   !*  Agilent Technologies shall not be liable for
5330   !* any infringement of any patent, trademark,
5340   !* copyright or other proprietary rights by the
5350   !* SAMPLE PROGRAM or its use. Agilent Technologies
5360   !* does not warrant that the SAMPLE PROGRAM is
5370   !* free from infringements or such rights of third
5380   !* parties. However, Agilent Technologies will not
5390   !* knowingly infringe or deliver a software that
5400   !* infringes the patent, trademark, copyright or
5410   !* other proprietary right of a third party.
5420   !*
5430   !*************************************************
